
/*
 * Inline example that uses SNF library, usable in userspace and kernel
 *
 * It is not a supported interface in any way, but is meant as an example of
 * what can be done with the SNF API.
 */
struct inl_options {
  int verbose; /* More verbose in output */
  int tx_num_tries; /* How many times to try in TX before dropping packet */
  int tx_timeout_ms;
  uint64_t num_pkts_expected; /* Break out after how many packets? */
};

void inl_init(struct inl_options *opts);
int  inl_num_devices(int *numdev);
int  inl_add(int board_rx, int board_tx, int num_rings, unsigned cpumask);
void inl_dump_stats(void);
int  inl_start(void);
void inl_stop(void);
void inl_wait(void);
