/************************************************************************
 * The contents of this file are subject to the MYRICOM MYRINET		*
 * EXPRESS (MX) NETWORKING SOFTWARE AND DOCUMENTATION LICENSE (the	*
 * "License"); User may not use this file except in compliance with the	*
 * License.  The full text of the License can found in LICENSE.TXT	*
 *									*
 * Software distributed under the License is distributed on an "AS IS"	*
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.  See	*
 * the License for the specific language governing rights and		*
 * limitations under the License.					*
 *									*
 * Copyright 2011 by Myricom, Inc.  All rights reserved.		*
 ************************************************************************/
#include <linux/module.h>
#include "mx_arch.h"
#include "myri_klib.h"
#include "snf.h"

#define MYRI_KAPI_VER	__stringify(SNF_VERSION_API)
#define	MYRI_KAPI_NAME	"Myricom sniffer kernel API driver"

MODULE_AUTHOR("Maintainer: help@myri.com");
MODULE_DESCRIPTION(MYRI_KAPI_NAME);
MODULE_LICENSE("Proprietary");
MODULE_VERSION(MYRI_KAPI_VER);

static void myri_snf_kapi_cleanup(void)
{
	myri_finalize_klib();
}

static int __init myri_snf_kapi_init(void)
{
	int error;

  	MX_INFO(("%s, version %s\n", MYRI_KAPI_NAME, MYRI_KAPI_VER));

	/* initialize the kernel library */
	error = myri_init_klib();
	if (error) {
		MX_WARN(("Kernel Lib Initialization failure\n"));
		myri_snf_kapi_cleanup();
		return -error;
	}

  	MX_INFO(("%s enabled\n", MYRI_KAPI_NAME));

	return 0;
}

static void __exit myri_snf_kapi_exit(void)
{
	myri_snf_kapi_cleanup();
  	MX_INFO(("%s disabled\n", MYRI_KAPI_NAME));
}

module_init(myri_snf_kapi_init);
module_exit(myri_snf_kapi_exit);
